<?
// ActiveIRC
// by jedi < jedi @ postboks.org >  -- http://jedi.postboks.org
// Script shows who is online on irc.

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}


class activeirc
{

	var $class    = "";
	var $sep_char = "";
	
	/*-------------------------------------------------------------------------*/
	// register_class
	// ------------------
	// Register a $this-> class with this module
	/*-------------------------------------------------------------------------*/
	
	function register_class(&$class)
	{
		$this->class = $class;
		
		$this->sep_char = '<{ACTIVE_LIST_SEP}>';
	}
	
	/*-------------------------------------------------------------------------*/
	//
	// DISPLAY ACTIVE USERS
	//
	/*-------------------------------------------------------------------------*/
	
	function active_users()
	{
		global $DB, $std, $ibforums;
		
		$activeirc = array( 'TOTAL'   => 0 ,
					  	    'OPS'     => 0,
						    'MEMBERS' => 0 ,
							'NAMES'   => "",
							'UPDATED' => "",
							'CHANNEL' => "",
							'LINK'    => "",
					      );
					   
		$stats_html = "";
		
		if ($ibforums->vars['show_activeirc'])
		{
			//-----------------------------------------
			// Get the users from the DB
			//-----------------------------------------
			
			$chan = $ibforums->vars['activeirc_chan'];
			
			$DB->simple_construct( array( 'select' => 'online,updated',
										  'from'   => 'activeirc',
										  'where'  => "chan='$chan'",
										  //'order'  => "running_time DESC" // Sort in PHP to avoid filesort in SQL
								 )      );
			
			
			$DB->simple_exec();
			
			//-----------------------------------------
			// FETCH DATA...
			//-----------------------------------------

			$users = array();
			
			$row = $DB->fetch_row();
			$users = split(" ",$row['online']);
			$activeirc['UPDATED'] = date($ibforums->vars['clock_short'],$row['updated']);
			$activeirc['CHANNEL'] = substr($ibforums->vars['activeirc_chan'],1).' @ '.$ibforums->vars['activeirc_network'];
			$activeirc['LINK'] = '<a href="irc://'.$ibforums->vars['activeirc_server'].'/'.substr($ibforums->vars['activeirc_chan'],1).'">'.$ibforums->vars['activeirc_chan'].' @ '.$ibforums->vars['activeirc_network'].'</a>';
			
			$ops = array();
			$regs = array();
			foreach ($users as $user) {
				if (preg_match("/^\@/",$user)) {
				  $activeirc['OPS']++;
				  array_push($ops,$user);
				}
				else {
				  $activeirc['MEMBERS']++;
				  array_push($regs,$user);
				}
				$activeirc['TOTAL']++;
			}

/*			natcasesort($ops);
			natcasesort($regs);
			$activeirc['NAMES'] = join(", ",array_merge($ops,$regs));
*/			
			natcasesort($users);
			$activeirc['NAMES'] = join(", ",$users);

			return $this->class->html->activeircusers($activeirc, $ibforums->vars['au_cutoff']);
		}
		
	}
	
}




?>